﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Collections;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.IO;
using System.Net.Http;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Xml.Linq;
using Newtonsoft.Json;

namespace XuniWeather
{
    class WeatherData
    {
        public async Task<ObservableCollection<WeatherModel>> GetResult()
        {

            return await GetWeather("15232");
        }
        private static async Task<ObservableCollection<WeatherModel>> GetWeather(string location)
        {
            var url = string.Format("http://api.openweathermap.org/data/2.5/forecast?zip={0}&units=imperial&APPID=a0a0e5e6d1ded0c79e853990c86f957b", location);

            var client = new HttpClient();
            var response = await client.GetAsync(url);
            if (response.IsSuccessStatusCode)
            {
                ObservableCollection<WeatherModel> weatherList = new ObservableCollection<WeatherModel>();
                string content = await response.Content.ReadAsStringAsync();

                var data = JsonConvert.DeserializeObject<WeatherResult>(content);
                WeatherModel model;
                foreach (var item in data.list)
                {
                    model = new WeatherModel();
                    model.date = Convert.ToDateTime(item.dt_txt);
                    model.humidity = item.main.humidity;
                    model.pressure = item.main.pressure;
                    model.description = item.weather[0].description;
                    model.hightemp = item.main.temp_min;
                    model.lowtemp = item.main.temp_max;
                    weatherList.Add(model);
                }
                return weatherList;
            }
            else
            {
                throw new Exception(await response.Content.ReadAsStringAsync());
            }
        }
}
    public class WeatherResult
    {
        public City city { get; set; }
        public int cod { get; set; }
        public double message { get; set; }
        public int cnt { get; set; }
        public List<WeatherList> list { get; set; }
    }

    public class Coord
    {
        public double lon { get; set; }
        public double lat { get; set; }
    }
    public class Sys
    {
        public int population { get; set; }
    }
    public class OtherSys
    {
        public string pod { get; set; }
    }
    public class City
    {
        public int id { get; set; }
        public string name { get; set; }
        public Coord coord { get; set; }
        public string country { get; set; }
        public int population { get; set; }
    }
    public class Weather
    {
        public int id { get; set; }
        public string main { get; set; }
        public string description { get; set; }
        public string icon { get; set; }
    }
    public class Clouds
    {
        public int all { get; set; }
    }
    public class Wind
    {
        public double speed { get; set; }
        public double deg { get; set; }
    }
    public class Rain
    {
        public double? amount { get; set; }
    }
    public class WeatherList
    {
        public int dt { get; set; }
        public Main main { get; set; }
        public List<Weather> weather { get; set; }
        public Clouds clouds { get; set; }
        public Rain rain { get; set; }
        public Wind wind { get; set; }
        public OtherSys sys { get; set; }
        public string dt_txt { get; set; }
    }
    public class Main
    {
        public double temp { get; set; }
        public double temp_min { get; set; }
        public double temp_max { get; set; }
        public double pressure { get; set; }
        public double sea_level { get; set; }
        public double grnd_level { get; set; }
        public int humidity { get; set; }
        public double temp_kf { get; set; }
    }
}

